import "Turbine.UI"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement


-- no laughing at the back I don't do LUA

--create Window
skirmWindow=Turbine.UI.Lotro.Window(); 
skirmWindow:SetSize(300,500); 
skirmWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-150,Turbine.UI.Display:GetHeight()/2-250); 
skirmWindow:SetText("Skirmish Raid Tracker"); 


-- List of skirmishes probably should put this in it's own file
-- Ahh the dreaded do arrays start at 0 or 1 seems to start at 0 if you use [] and 1 otherwise

skirmishes={
"Ford of Bruinen",
"Siege of Gondamon",
"Trouble in Tuckborough",
"Stand at Amon Sul",
"Strike Against Dannenglor",
"Protectors of Thangulhad",
"Breaching the Necromancer's Gate",
"Assault on the Ringwraiths' Lair",
"Battle in the Tower",
"Defense of the Prancing Pony",
"Thievery and Mischief",
"Rescue in Nurz Ghashu",
"Battle of the Deep-Way",
"Battle of the Way of Smiths",
"Battle of the Twenty-First Hall",
"The Icy Crevasse",
"Attack at Dawn"
};

local skTotal=table.maxn(skirmishes);  -- wonder what else I should make local?

skirmWindow.skcb = { };

-- Put checkboxes in window
for i = 1, skTotal do
	skirmWindow.skcb[i]=Turbine.UI.Lotro.CheckBox();
	skirmWindow.skcb[i]:SetParent(skirmWindow);
	skirmWindow.skcb[i]:SetSize(280,20);
	skirmWindow.skcb[i]:SetPosition(10,20 +(i*25));
	skirmWindow.skcb[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	skirmWindow.skcb[i]:SetText(" " .. skirmishes[i]);
end
-- Add the buttons
skirmWindow.SaveBtn =Turbine.UI.Lotro.Button();
skirmWindow.SaveBtn:SetText("Save");
skirmWindow.SaveBtn:SetPosition( 40, 470 );
skirmWindow.SaveBtn:SetSize( 90, 20 );
skirmWindow.SaveBtn:SetParent(skirmWindow);

skirmWindow.ResetBtn =Turbine.UI.Lotro.Button();
skirmWindow.ResetBtn:SetText("Reset All");
skirmWindow.ResetBtn:SetPosition( 170, 470 );
skirmWindow.ResetBtn:SetSize( 90, 20 );
skirmWindow.ResetBtn:SetParent(skirmWindow);

-- I don't know LUA but this is screaming out to me as bad should be in a LoadSettings

settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "SkirmishTracker" );

	if ( type( settings ) ~= "table" ) then
		settings = { };
		settings.positionX=Turbine.UI.Display:GetWidth()/2-150;
		settings.positionY=Turbine.UI.Display:GetHeight()/2-250;
		settings.skirmishDone = {};
	end
	
	skirmWindow:SetPosition(settings.positionX, settings.positionY);
	
	for i=1,skTotal do
		skirmWindow.skcb[i]:SetChecked(settings.skirmishDone[i]);
	end

-- 

skirmWindow:SetVisible(true);

-- Bit so you can show window from chat

SkirmishTrackerCommand = Turbine.ShellCommand();

function SkirmishTrackerCommand:Execute( command, arguments )
	skirmWindow:SetVisible( true );
end

Turbine.Shell.AddCommand("sktr", SkirmishTrackerCommand);

-- Button Events
skirmWindow.ResetBtn.Click = function( sender, args )
	for i=1,skTotal do
	skirmWindow.skcb[i]:SetChecked(false);
	end
end

skirmWindow.SaveBtn.Click = function( sender, args )
	for i=1,skTotal do
	settings.skirmishDone[i]=skirmWindow.skcb[i]:IsChecked();
	end
	Turbine.PluginData.Save( Turbine.DataScope.Character, "SkirmishTracker", settings );
end

-- Hopefully this tracks windows position - makes save button redundant I think too
skirmWindow.MouseLeave = function( sender, args )

	X, Y = skirmWindow:GetPosition();
	settings.positionX=X;
	settings.positionY=Y;
	skirmWindow.SaveBtn.Click(); -- bad wal

end
